This section will show you how to deploy your project on different environments.

## Setup

First of all you'll need to install [MobaXterm](https://mobaxterm.mobatek.net/download.html) in order to connect to the server.
Then, if your're on Linux you can skip the following section, otherwise if you are on Windows you'll have to install Windows Subsystem for Linux (WSL) since the deployment of the app is not working with windows commands.

## Configuration of MobaXterm

First open a new session and connect to the distant host **51.158.104.84**. Don't forget to add the path to the private key in the advanced SSH settings. Also don't forget to ask an administrator to add your public key so you can access the server.

## Deploy Ecolyo

### Deploy on Alpha - Scaleway

There is 2 environment you can deploy on alpha for testing:

- ecolyo_dev
- ecolyo_test

#### Windows

If you use windows, make sure you have WSL installed and a Linux distribution. For more information about it see the [Install WSL section](../getting_started/setup_your_environment.md)

First open your Ubuntu terminal (or any other distribution you've installed), and clone the project in the repertory of your choice. Once you've selected the branch of you want to deploy, write the following command :

```
yarn build
```

After this, you can launch the deployment.
In order to deploy on ecolyo_dev (development environment) use the command :

```
yarn deploy-dev
```

For test environment ecolyo_testuse the command :

```
yarn deploy-test
```

If you want to deploy on the ecolyo-build environment, use :

```
yarn deploy
```

#### Linux

From your current branch, run `yarn build` then `sudo yarn deploy_dev` to instantly deploy your working branch on the latest tagged Ecolyo-dev container registry.

### Create an instance

If you want to create a specific instance, please ask for the admin.

### Reset your instance

Once you've deployed your branch, connect to Scaleway server using mobaXterm (or any other software), and then go to the admin-scripts folder in easy-cozy

```
cd easy-cozy/admin_scripts
```

If you want to reset your instance, use the script reset_instance.sh with the name of your instance

```
./reset-instance.sh <instance-name>
```

You'll be prompted for the complete url of your instance in order to confirm the reset

```
<instance-name>.cozy.self-data.alpha.grandlyon.com
```

After this, you'll have to activate your cozy instance by clicking on the prompted url with the registration token and choose a password for your instance.
Once it is done, you can process on the update of your app.

#### Update Ecolyo App

In order to update your app, you can execute the script depending on the branch you deployed. Keep in mind to prioritize using ecolyo_test for your testings.

```
./update_ecolyo_test.sh <instance-name>
```

Now you can access your updated version of Ecolyo with the following URl, enjoy : `ecolyo.instance-name.cozy.self-data.alpha.grandlyon.com`
